package org.apache.bcel.util;

import java.lang.ref.SoftReference;
import java.util.HashMap;
import java.util.Map;
import org.apache.bcel.classfile.JavaClass;

public class MemorySensitiveClassPathRepository extends AbstractClassPathRepository {
   private final Map<String, SoftReference<JavaClass>> loadedClasses = new HashMap();

   public MemorySensitiveClassPathRepository(ClassPath path) {
      super(path);
   }

   public void clear() {
      this.loadedClasses.clear();
   }

   public JavaClass findClass(String className) {
      SoftReference<JavaClass> ref = (SoftReference)this.loadedClasses.get(className);
      return ref == null ? null : (JavaClass)ref.get();
   }

   public void removeClass(JavaClass clazz) {
      this.loadedClasses.remove(clazz.getClassName());
   }

   public void storeClass(JavaClass clazz) {
      this.loadedClasses.put(clazz.getClassName(), new SoftReference(clazz));
      clazz.setRepository(this);
   }
}
